"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator.throw(value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments)).next());
    });
};
const mongodb_1 = require("mongodb");
class MongoConnector {
    constructor(url) {
        this.mongoUrl = url;
    }
    connect(started) {
        return new Promise((resolve, error) => {
            const that = this;
            mongodb_1.MongoClient.connect(this.mongoUrl, function (err, db) {
                if (err) {
                    console.log('Connection Error: ' + err);
                    return;
                }
                console.log('Connected to MongoDB at ' + that.mongoUrl);
                that.db = db;
                if (started) {
                    started();
                }
                resolve(db);
            });
        });
    }
    disconnect() {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.db.close();
        });
    }
    dispose() {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.db.dropDatabase();
            yield this.disconnect();
        });
    }
    collection(name) {
        return this.db.collection(name);
    }
}
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = MongoConnector;
